#!/usr/bin/perl

use strict;
use Socket;

main();

sub main(){
    my $options="";	    # default options
    my $login="login";	    # your login
    my $banner=banner($ENV{'PATH_INFO'} || "/$login",$ENV{'QUERY_STRING'} || $options);
    print "Content-type: text/html\nContent-Length: ".length($banner)."\n\n",$banner;
}

sub banner{
    my ($login,$query)=@_;
    my $mirror="kbe.rotabanner.com";	    # nearest mirror IP
    my $timeout=2;			    # timeout in seconds
    my $random=int rand(10000000);	    # random number
    my $charset=$ENV{'SOURCE_CHARSET'};	    # Russian Apache charset autodetect
    my $headers={
	'REFERER'	    => "http://".$ENV{'SERVER_NAME'}.$ENV{'REQUEST_URI'},   # we need to pass 
	'USER-AGENT'	    => $ENV{'HTTP_USER_AGENT'},				    # these headers
	'X_FORWARDED_FOR'   => $ENV{'HTTP_X_FORWARDED_FOR'},			    # into subrequests
	'REMOTE_ADDR'	    => $ENV{'REMOTE_ADDR'}				    #
    };

    $query="&charset=$charset".($query ? "&":"").$query;
    request($login,$mirror,$query,$timeout,$headers,$random) || default($login,$mirror,$query,$random);
}

sub default{
    my ($login,$mirror,$query,$random)=@_;
    "<a href=\"http://$mirror/cgi-bin/href$login?$random\" target=_top>".
    "<img src=\"http://$mirror/cgi-bin/banner$login?$random$query\" alt=\"List Banner Exchange\" width=470 height=60 border=0 ismap>".
    "</a>";
}

sub request{
    my ($login,$mirror,$query,$timeout,$headers,$random)=@_;
    $query=~tr/ /+/;

    my $banner;
    my $request="GET /cgi-bin/iframe$login?$random&ssi=yes$query HTTP/1.0\nHOST: $mirror\n";
    while (my ($name,$value)=each %$headers){
	$request.="$name: $value\n" if $value;
    }

    local $SIG{ALRM}= sub { die };
    local $/=undef;

    alarm($timeout);
    eval {
	$banner=http($mirror,$request);
    };
    close(SOCK);

    return "" if $@;
    return "" unless ($banner=~ /^HTTP\/[^ ]* (\d+)/) && ($1==200);
    $banner=~/\r?\n\r?\n/s;
    return $';
}

sub http{
    my ($host,$headers)=@_;
    my $thataddr=gethostbyname($host);

    return "[unable to resolve host name]" unless $thataddr;
    return "[socket create error]" unless socket(SOCK,PF_INET,SOCK_STREAM,getprotobyname('tcp'));
    return "[socket connect error]" unless connect(SOCK,pack('S n a4 x8',PF_INET,80,$thataddr));
    select(SOCK); $|=1; select(STDOUT);
    print SOCK "$headers\n";
    <SOCK>
}
